/* xxsorp02.p Open SO XL report */
{mfdtitle.i "a06"}
define temp-table t
  field tNbr    as character
  field tDue    as date
  field tSamp   as logical
  field tHold   as logical
  field tAlloc  as logical
  field tConf   as logical
  index ti tDue tNbr.
define temp-table d
  field dNbr    as character
  field dLn     as integer
  field dQohl   as decimal   format "->,>>>,>>9.99"
  index di dnbr dln.
define temp-table s
  field sSite   as character
  field sPart   as character
  field sQoh    as decimal   format "->,>>>,>>9.99"
  index si sSite sPart.
define new shared temp-table srt no-undo
  field stPart   as character
  field stOrd    as integer
  field stln     as integer
  field stQty    as decimal  format "->,>>>,>>9.99"
  field stSales  as decimal  format "->,>>>,>>9.99"
  field stlOrd   as character
  index srti is primary stPart
  index s2 stSales descending  .

define temp-table sum no-undo
  field smStart  as date
  field smEnd    as date
  field smCompl  as logical
  field smln     as integer
  field smOrd    as integer
  field smQty    as decimal  format "->,>>>,>>9.99"
  field smSales  as decimal  format "->,>>>,>>9.99"
  field smhln    as integer
  field smhOrd   as integer
  field smhQty   as decimal  format "->,>>>,>>9.99"
  field smhSales as decimal  format "->,>>>,>>9.99"
  field smlOrd   as character
  field smConf   as logical
  index srti is primary smStart .

/*FUNC DECLARATIONS*/
function snapshotStock returns logical() forward.
function allocateStock returns logical() forward.
function handleDue     returns logical() forward.
function calcShortage  returns logical() forward.
function writeSummary  returns logical() forward.
function writeShortage returns logical() forward.

define new shared variable siteList as char no-undo init "2500,3000".

{gpcurrp.i}
define variable due   like sod_due_date.
define variable due1  like sod_due_date.
define variable req  like sod_due_date.
define variable req1 like sod_due_date.
define new shared variable allocBy as character format "x(14)" view-as combo-box
  list-items "Due Date","Promised Date","Required Date" initial "Required Date"
  label "Allocate By".
define variable ordType as char format "x(12)" view-as combo-box
    list-items "Confirmed","Unconfirmed","Both" initial "Both"
    label "Order Types".
define variable iMode as character format "X(9)" view-as combo-box
    list-items "Detail","Summary","Shortage","Component" initial "Detail"
    label "Mode".
define variable shiptoName as char.
define variable rndmthd like rnd_rnd_mthd no-undo.
define variable oldcurr like so_curr no-undo.
define variable cust like so_cust.
define variable cust1 like so_cust.
define variable ship like so_cust.
define variable ship1 like so_cust.
define variable site  like so_site.
define variable site1 like so_site.
define variable sonbr like so_nbr.
define variable sonbr1 like so_nbr.
define variable ord like so_ord_date.
define variable ord1 like so_ord_date.
define variable name like ad_name.
define variable qty_open like sod_qty_ord .
define variable desc1 like pt_desc1 format "x(49)".
define variable base_rpt like so_curr.
define variable stat like so_stat.
define variable stat1 like so_stat.
define variable pl  like sod_prodline.
define variable pl1 like sod_prodline.
define variable vAlloc as logical no-undo.
define variable spsn like sp_addr.
define variable spsn1 like spsn.
define variable po like so_po.
define variable po1 like so_po.
define variable include_allocated like mfc_logical initial yes.
define variable include_picked like mfc_logical initial yes.
define variable include_shipped like mfc_logical initial yes.
define variable include_unprocessed like mfc_logical initial yes.
define variable print_options like mfc_logical initial no.
define variable show_comments like mfc_logical initial no.
define variable i as integer.
define variable options_qty like sob_qty_req.
define variable options_desc1 like pt_desc1.
define variable options_desc2 like pt_desc2.
define variable options_um like pt_um.
define variable print_customer_header like mfc_logical.
define variable base_price like sod_price.
define variable curr_price like sod_price.
define variable ext_base_price like sod_price format "->,>>>,>>>,>>9.99".
define variable ext_base_price_unrnd like sod_price.
define variable ext_curr_price like sod_price format "->,>>>,>>>,>>9.99".
define variable ext_curr_price_unrnd like sod_price.
define variable l_new_so like mfc_logical initial no no-undo.
define variable v_disp_line1    as   character format "x(40)".
define variable v_disp_line2    as   character format "x(40)" no-undo.
define variable v_cust_po       as   character format "x(31)" no-undo.
define variable v_cust_po_label as   character                no-undo.
define variable mc-error-number like msg_nbr no-undo.
{gprunpdf.i "mcpl" "p"}
{gprunpdf.i "mcui" "p"}
oldcurr = "".

function getStart returns date (iDate as date):
    do while(iDate > due):
        if weekday(iDate) = 2 then leave.
        iDate = iDate - 1.
    end.
    return iDate.
end function.
function getEnd returns date (iDate as date):
    do while(iDate < due1):
        if weekday(iDate) = 1 then leave.
        iDate = iDate + 1.
    end.
    return iDate.
end function.

form
    site      colon 15                          site1 label {t001.i} colon 49
    sonbr       colon 15                        sonbr1 label {t001.i} colon 49
    ord       colon 15                          ord1  label {t001.i} colon 49
    due       colon 15                          due1  label {t001.i} colon 49
    req       colon 15 label "Required Date"    req1  label {t001.i} colon 49
    cust      colon 15 label "Customer"         cust1 label {t001.i} colon 49
    ship      colon 15 label "Ship-to"          ship1 label {t001.i} colon 49
    spsn      colon 15                          spsn1 label {t001.i} colon 49
    pl        colon 15                          pl1   label {t001.i} colon 49
    siteList  colon 15 label "Site List" format "x(20)"
    ordType    colon 49
    allocBy   colon 15
with frame a side-labels width 80.


repeat :
   hide message no-pause.
   if sonbr1  = hi_char then sonbr1 = "".
   if site1 = hi_char then site1 = "".
   if cust1 = hi_char then cust1 = "".
   if ship1 = hi_char then ship1 = "".
   if ord = low_date then ord = ?.
   if ord1 = hi_date then ord1 = ?.
   if due = low_date then due = ?.
   if due1 = hi_date then due1 = ?.
   if req = low_date then req = ?.
   if req1 = hi_date then req1 = ?.
   if stat1 = hi_char then stat1 = "".
   if spsn1 = hi_char then spsn1 = "".
   if pl1 = hi_char then pl1 = "".
   if po1 = hi_char then po1 = "".

   update
          site site1
          sonbr sonbr1
          ord ord1
          due due1
          req req1
          cust cust1
          ship ship1
          spsn spsn1
          pl pl1
          siteList
          ordType
          allocBy
        with frame a.

   bcdparm = "".
   if sonbr1 = "" then sonbr1 = hi_char.
   if site1 = "" then site1 = hi_char.
   if cust1 = "" then cust1 = hi_char.
   if ship1 = "" then ship1 = hi_char.
   if ord = ? then ord = low_date.
   if ord1 = ? then ord1 = hi_date.
   if due = ? then due = low_date.
   if due1 = ? then due1 = hi_date.
   if req = ?  then req = low_date.
   if req1 = ? then req1 = hi_date.
   if stat1 = "" then stat1 = hi_char.
   if spsn1 = "" then spsn1 = hi_char.
   if pl1 = "" then pl1 = hi_char.
   if po1 = "" then po1 = hi_char.


   {gpselout.i &printType = "printer"
               &printWidth = 440
               &pagedFlag = " "
               &stream = " "
               &appendToFile = " "
               &streamedOutputToTerminal = " "
               &withBatchOption = "yes"
               &displayStatementType = 1
               &withCancelMessage = "yes"
               &pageBottomMargin = 6
               &withEmail = "yes"
               &withWinprint = "yes"
               &defineVariables = "yes"}


/*AK** put screen row 22 "Report is running...".
/*AK*/    output through ("32printer") paged . **/
/* 32printer script should be in the PATH, here is the content"
#######################
#!/bin/sh
echo -n -e '\033[5i'
cat $1
echo -n -e '\033[4i'
#######################

Alternatively use gzprn32.sh - with compression
it should be in the PATH, here is its content
#######################
#!/bin/sh
#
# $1 - file to print
#
prtSwitch='@@@^32PRINTER-SWITCH^@@@'
# NOTE: prtSwitch variable MUST BE the same as in main.ini file
echo -ne "\033[5i"
if [ ! -z "$2" ]; then
    echo -ne "${prtSwitch}${2}\n"
fi
gzip -c9 < "$1" | uuencode 32PRINTER
# NOTE: uuencode must have '32PRINTER' parameter (checked by prnloc.exe)
echo -ne "\033[4i"
#######################
*/

/*AK*/    put "#Excel template so_report.xls" skip.


    if iMode = "Detail" then do:

put unformatted
"SO Nbr   PO                      Ordered " + string(allocBy, "X(13)") +
"   Ln Due W Promised Required Perform  Line Item               Description" +
"                                       UM              Qty Ord             " +
"Qty Ship             Qty Open          Qty Left OH         Base Price      " +
"    Ext Price Curr                 Ex Rate           Std Cost Customer     " +
"                Ship-to                      Slsman   Site     PL   " +
"Type Remarks                                  Channel  Sample  Alloc   " +
"Hold   Conf" skip.
put unformatted
"-------- ---------------------- -------- ------------- -------- - -------- " +
"-------- -------- ---- ------------------ ---------------------------------" +
"---------------- -- -------------------- -------------------- -------------" +
"------- -------------------- ------------------ ------------------ ---- ---" +
"-------------------- ------------------ ---------------------------- ------" +
"---------------------- -------- -------- ---- ---- ------------------------" +
"---------------- -------- ------ ------ ------ ------" skip.
    end.

    allocateStock().

    for each so_mstr no-lock
       where so_domain = global_domain
         and (so_nbr >= sonbr) and (so_nbr <= sonbr1)
         and not so_sched
         and (so_cust >= cust) and (so_cust <= cust1)
         and (so_ship >= ship) and (so_ship <= ship1)
         and (so_ord_date >= ord) and (so_ord_date <= ord1)
         and (so_slspsn[1] >= spsn) and (so_slspsn[1] <= spsn1)
         and (so_stat >= stat) and (so_stat <= stat1)
         and (so_po >= po) and (so_po <= po1)
         and (base_rpt = so_curr or base_rpt = "")
         and (ordType = "Confirmed" and so_conf_date <> ? or ordType = "Both" or ordType = "Unconfirmed" and so_conf_date = ?),
       first t
       where tNbr = so_nbr
       break by so_due_date
             by so_nbr :

        /* CHECK IF ANY SALES ORDER IS BEING CREATED */
        l_new_so = no.
        {gprun.i ""sonewso.p"" "(input recid(so_mstr), output l_new_so)"}

        if not l_new_so then do:
            if (oldcurr <> so_curr) or (oldcurr = "") then do:
                {gprunp.i "mcpl" "p" "mc-get-rnd-mthd"
                        "(input  so_curr,
                          output rndmthd,
                          output mc-error-number)" }
                if mc-error-number <> 0 then do:
                    {mfmsg.i mc-error-number 4}
                    if c-application-mode <> 'WEB':U then
                        pause.
                    undo, next.
                end.
                oldcurr = so_curr.
           end.

            name = "".
            for first cm_mstr no-lock
                where cm_domain = global_domain
                  and cm_addr = so_cust:
            end.
            if available cm_mstr then name = cm_sort.
            shiptoName = "".
            for first ad_mstr no-lock
                where ad_domain = global_domain
                  and ad_addr = so_ship:
            end.
            if available ad_mstr then shiptoName = ad_name.

            /* GET SALES ORDER RECORD  */
            for each sod_det no-lock
               where sod_domain = global_domain
                 and sod_nbr = so_nbr
                 and (sod_site >= site and sod_site <= site1)
                 and not sod_sched
                 and ((include_allocated and sod_qty_all <> 0) or
                      (include_picked and sod_qty_pick <> 0) or
                      (include_shipped and sod_qty_ship <> 0) or
                      (include_unprocessed and sod_qty_all = 0
                                           and sod_qty_pick = 0
                                           and sod_qty_ship = 0))
                 and (sod_due_date >= due and sod_due_date <= due1)
                 and (sod_req_date >= req and sod_req_date <= req1)
                 and (sod_prodline >= pl and sod_prodline <= pl1)
               break by sod_nbr
                     by sod_line:

                qty_open = sod_qty_ord - sod_qty_ship.
                if sod_qty_ord > 0 and qty_open < 0 then qty_open = 0.
                if sod_qty_ord < 0 and qty_open > 0 then qty_open = 0.

                /* SET PRICE FOR CURR AND BASE */
                curr_price = sod_price.
                run getExtPrice (input so_curr,
                                 input so_ex_rate,
                                 input so_ex_rate2,
                                 input sod_price,
                                 input qty_open).

                /* PRINT DETAIL LINE */
                if iMode = "Detail" then do:
                  desc1 = sod_desc.
                  for first pt_mstr no-lock
                      where pt_domain = global_domain
                         and pt_part = sod_part:
                  end.
                  if available pt_mstr then desc1 = pt_desc1 + " " + pt_desc2.

                  find first d where dNbr = sod_nbr and dLn = sod_line no-error.
                  define variable chartdue as character.
                  define variable w as character format "X".
                  chartdue = if tdue = hi_date or tdue = low_date then ""
                             else string(tdue).
                  w = if tDue <> sod_due_date then "W" else "".

                  put
                      so_nbr                                   at   1
                      so_po                                    at  10
                      so_ord_date                              to  40
                      chartDue                                 to  54
                      sod_due_date                             to  63
                      w                                        to  65
                      sod_promise_date                         to  74
                      sod_req_date                             to  83
                      sod_per_date                             to  92
                      sod_line                                 to  97
                      sod_part                                 at  99
                      desc1                                    to 166
                      sod_um                                   at 168
                      sod_qty_ord                              to 190
                      sod_qty_ship                             to 211
                      qty_open                                 to 232
                      if available d then dQohl else 0         to 253
                      base_price                               to 272
                      ext_base_price                           to 291
                      so_curr                                  at 293
                      so_ex_rate                               to 320
                      sod_std_cost                             to 339
                      name                                     at 341
                      shiptoName                               at 370
                      so_slspsn[1]                             at 399
                      sod_site                                 at 408
                      sod_prodline                             at 417
                      sod_type                                 at 422
                      so_rmks                                  at 427
                      so_channel                               at 468
                      tSamp                                    to 482
                      tAlloc                                   to 489
                      tHold                                    to 496
                      tConf                                    to 503
                      skip.
                end.

                find first sum
                     where smStart = getStart(tDue)
                       and smCompl = tAlloc no-error.
                if not available sum then do:
                    create sum.
                    smStart = getStart(tDue).
                    smEnd   = getEnd(tDue).
                    smCompl = tAlloc.
                    smConf = tConf.
                end.

                if not tHold then
                    assign
                        smln    = smln    + 1
                        smQty   = smQty   + qty_open
                        smSales = smSales + ext_base_price
                        smOrd   = if smlOrd <> sod_nbr then smOrd + 1 else smOrd
                        smlOrd  = sod_nbr  .
                else
                    assign
                        smhln    = smhln    + 1
                        smhQty   = smhQty   + qty_open
                        smhSales = smhSales + ext_base_price
                        smhOrd   = if smlOrd <> sod_nbr then smhOrd + 1
                                   else smhOrd
                        smlOrd  = sod_nbr  .
            end.  /* end Get Sales Order detail */
        end. /* IF NOT NEW SALES ORDER */
    end. /* for each so_mstr */

    if iMode = "Summary" then
        writeSummary().
    else if iMode = "Shortage" then
        writeShortage().
    else if iMode = "Component" then do:
        /*COMPONENTS*/
        {gprun.i ""xxsorp2a.p""}
    end.
    else do:
        put "NextExcelWorksheet" at 1 skip.
        page.
        writeSummary().
        put "NextExcelWorksheet" at 1 skip.
        page.
        writeShortage().
        put "NextExcelWorksheet" at 1 skip.
        page.
        {gprun.i ""xxsorp2a.p""}
    end.

/*AK** output close.
 put screen row 22 "". **/

    message "done".
    {mfrtrail.i}

end.    /*repeat*/


procedure getExtPrice :
    define input param sCrr   as character.
    define input param sexr   as decimal.
    define input param sexr2  as decimal.
    define input param sprice as decimal.
    define input param iQty   as decimal.
    {gprunp.i "mcpl" "p" "mc-curr-conv"
        "(input  sCrr,
          input  base_curr,
          input  sexr,
          input  sexr2,
          input  sprice,
          input  false,  /* DO NOT ROUND */
          output base_price,
          output mc-error-number)" }
    if mc-error-number <> 0 then do:
        {mfmsg.i mc-error-number 2}
    end.

    /* CALCULATE EXTENDED PRICE AND BASE TOTAL */
    ext_curr_price = iqty * curr_price.

    /* ROUND EXTENDED PRICE PER DOCUMENT CURRENCY */
    /* CONVERT EXTENDED PRICE AND ROUND PER BASE */
    {gprunp.i "mcpl" "p" "mc-curr-conv"
        "(input  scrr,
          input  base_curr,
          input  sexr,
          input  sexr2,
          input  ext_curr_price,
          input  false,  /* DO NOT ROUND */
          output ext_base_price,
          output mc-error-number)" }
    if mc-error-number <> 0 then do:
        {mfmsg.i mc-error-number 2}
    end.

    /* SAVE UNROUNDED VALUES */
    assign
        ext_curr_price_unrnd = ext_curr_price
        ext_base_price_unrnd = ext_base_price.
    {gprunp.i "mcpl" "p" "mc-curr-rnd"
       "(input-output ext_curr_price,
         input        rndmthd,
         output       mc-error-number)" }
    if mc-error-number <> 0 then do:
        {mfmsg.i mc-error-number 2}
    end.
    {gprunp.i "mcpl" "p" "mc-curr-rnd"
       "(input-output ext_base_price,
         input        rndmthd,
         output       mc-error-number)" }
end procedure.


function writeSummary returns logical():
    define variable sum1 as decimal extent 3.
    define variable sum2 as decimal extent 3.
    define variable sum3 as decimal extent 3.
    define variable sum4 as decimal extent 3.
    define variable sum5 as decimal extent 3.
    define variable sum6 as decimal extent 3.
    define variable sum7 as decimal extent 3.
    define variable sum8 as decimal extent 3.
    define variable period as character format "X(17)".
    define variable complete as character format "X(24)".
    sum1 = 0.
    sum2 = 0.
    sum3 = 0.
    sum4 = 0.
    sum5 = 0.
    sum6 = 0.
    sum7 = 0.
    sum8 = 0.

    for each sum
       where smConf and smCompl:

        period = string(smStart) + "-" + string(smEnd).
        complete = "Summary".

        display period     column-label "Week"
                complete   column-label "Complete"
                smOrd      column-label "# Orders"
                smln       column-label "# Lines"
                smQty      column-label "Units"
                smSales    column-label "Sales"
                smhOrd     column-label "# H Orders"
                smhln      column-label "# H Lines"
                smhQty     column-label "H Units"
                smhSales   column-label "H Sales"
            with down frame c width 160.

        sum1[1] = sum1[1] + smOrd   .
        sum2[1] = sum2[1] + smln    .
        sum3[1] = sum3[1] + smQty   .
        sum4[1] = sum4[1] + smSales .
        sum5[1] = sum5[1] + smhOrd  .
        sum6[1] = sum6[1] + smhln   .
        sum7[1] = sum7[1] + smhQty  .
        sum8[1] = sum8[1] + smhSales.

    end.

    put skip .

    display ""          @ period
            "SubTotal:" @ complete
            sum1[1]     @ smOrd
            sum2[1]     @ smln
            sum3[1]     @ smQty
            sum4[1]     @ smSales
            sum5[1]     @ smhOrd
            sum6[1]     @ smhln
            sum7[1]     @ smhQty
            sum8[1]     @ smhSales
        with frame d width 160 no-label.

    put skip(2).

    for each sum
       where smConf and not smCompl:

        period = string(smStart) + "-" + string(smEnd).
        complete = "Not Shippable".

        display period     column-label "Week"
                complete   column-label "Complete"
                smOrd      column-label "# Orders"
                smln       column-label "# Lines"
                smQty      column-label "Units"
                smSales    column-label "Sales"
                smhOrd     column-label "# H Orders"
                smhln      column-label "# H Lines"
                smhQty     column-label "H Units"
                smhSales   column-label "H Sales"
            with down frame e width 160.

        sum1[2] = sum1[2] + smOrd   .
        sum2[2] = sum2[2] + smln    .
        sum3[2] = sum3[2] + smQty   .
        sum4[2] = sum4[2] + smSales .
        sum5[2] = sum5[2] + smhOrd  .
        sum6[2] = sum6[2] + smhln   .
        sum7[2] = sum7[2] + smhQty  .
        sum8[2] = sum8[2] + smhSales.

    end.
    put skip.

    display ""          @ period
            "SubTotal:" @ complete
            sum1[2]     @ smOrd
            sum2[2]     @ smln
            sum3[2]     @ smQty
            sum4[2]     @ smSales
            sum5[2]     @ smhOrd
            sum6[2]     @ smhln
            sum7[2]     @ smhQty
            sum8[2]     @ smhSales
        with frame f width 160 no-label.

    put skip(2).

    for each sum
       where not smConf:

        period = string(smStart) + "-" + string(smEnd).
        complete = "Unconfirmed".

        display period     column-label "Week"
                complete   column-label "Complete"
                smOrd      column-label "# Orders"
                smln       column-label "# Lines"
                smQty      column-label "Units"
                smSales    column-label "Sales"
                smhOrd     column-label "# H Orders"
                smhln      column-label "# H Lines"
                smhQty     column-label "H Units"
                smhSales   column-label "H Sales"
            with down frame g width 160.

        sum1[3] = sum1[3] + smOrd   .
        sum2[3] = sum2[3] + smln    .
        sum3[3] = sum3[3] + smQty   .
        sum4[3] = sum4[3] + smSales .
        sum5[3] = sum5[3] + smhOrd  .
        sum6[3] = sum6[3] + smhln   .
        sum7[3] = sum7[3] + smhQty  .
        sum8[3] = sum8[3] + smhSales.

    end.

    display ""          @ period
            "SubTotal:" @ complete
            sum1[3]     @ smOrd
            sum2[3]     @ smln
            sum3[3]     @ smQty
            sum4[3]     @ smSales
            sum5[3]     @ smhOrd
            sum6[3]     @ smhln
            sum7[3]     @ smhQty
            sum8[3]     @ smhSales
        with frame h width 160 no-label.

    put skip(2).

    complete = "TOTAL:".

    display "" @ period
            complete
            sum1[1] + sum1[2] + sum1[3] @ smOrd
            sum2[1] + sum2[2] + sum2[3] @ smln
            sum3[1] + sum3[2] + sum3[3] @ smQty
            sum4[1] + sum4[2] + sum4[3] @ smSales
            sum5[1] + sum5[2] + sum5[3] @ smhOrd
            sum6[1] + sum6[2] + sum6[3] @ smhln
            sum7[1] + sum7[2] + sum7[3] @ smhQty
            sum8[1] + sum8[2] + sum8[3] @ smhSales
        with frame q width 160 no-label.
    return true.

end function.


function writeShortage returns logical().
    define variable sum1 as decimal.
    define variable sum2 as decimal.
    define variable sum3 as decimal.
    define variable sum4 as decimal.
    define variable period   as character format "X(17)".
    define variable complete as character format "X(24)".
    define variable i as integer.

    for each srt by stSales descending:
        i = i + 1.
        display i       column-label "##|#"
                stPart  column-label "Item Number"
                stOrd   column-label "# Orders"
                stln    column-label "# Lines"
                stQty   column-label "Units"
                stSales column-label "Sales"
            with down frame c width 132.

        sum1 = sum1 + stOrd  .
        sum2 = sum2 + stln   .
        sum3 = sum3 + stQty  .
        sum4 = sum4 + stSales.

    end.

    put skip.

    display ""       @ i
            "TOTAL:" @ stPart
            sum1     @ stOrd
            sum2     @ stln
            sum3     @ stQty
            sum4     @ stSales
     with down frame d width 132 no-label.
    return true.
end function.


function snapshotStock returns logical().
    for each s: delete s. end.
    for each in_mstr no-lock
       where in_domain= global_domain
         and lookup(in_site,siteList) <> 0,
       first sod_det no-lock
       where sod_domain = global_domain
         and sod_part = in_part  :

        find s where sPart = in_part no-error.
        if not avail s then do:
            create s.
            sPart = in_part.
        end.
        sQoh  = sQoh + in_qty_avail.
    end.
    return true.

end function.


function handleDue returns logical().
   soloop:
   for each so_mstr no-lock
      where so_domain = global_domain
        and (so_nbr >= sonbr and so_nbr <= sonbr1)
        and not so_sched
        and (so_cust >= cust and so_cust <= cust1)
        and (so_ship >= ship and so_ship <= ship1)
        and (so_ord_date >= ord and so_ord_date <= ord1)
        and (so_slspsn[1] >= spsn and so_slspsn[1] <= spsn1)
        and (so_stat >= stat and so_stat <= stat1)
        and (so_po >= po and so_po <= po1)
        and (base_rpt = so_curr or base_rpt = "")
        and (ordType = "Confirmed" and
        so_conf_date <> ? or ordType = "Both" or
        ordType = "Unconfirmed" and so_conf_date = ?) :

        create t.
        assign
          tNbr   = so_nbr
          tSamp  = if so_channel <> "" then yes else no
          tAlloc = no
          tHold  = if so_stat <> "" then yes else no
          tDue   = due1
          tConf  = if so_conf_date <> ? then yes else no.

        /*DO NOT ALLOCATE FOR SAMPLE ORDERS*/
        if tSamp then next soloop.

        /*DO NOT ALLOCATE FOR CREDIT HOLD*/
        if tHold then next soloop.

      sodloop:
      for each sod_det no-lock
        where sod_domain = global_domain
          and sod_nbr = so_nbr
          and (sod_site >= site and sod_site <= site1)
          and not sod_sched
          and ((include_allocated and sod_qty_all <> 0) or
               (include_picked and sod_qty_pick <> 0) or
               (include_shipped and sod_qty_ship <> 0) or
               (include_unprocessed and sod_qty_all = 0
                                    and sod_qty_pick = 0
                                    and sod_qty_ship = 0))
         and (sod_due_date >= due and sod_due_date <= due1)
         and (sod_req_date >= req and sod_req_date <= req1)
         and (sod_prodline >= pl and sod_prodline <= pl1)
       break by sod_nbr
             by sod_line:
            qty_open = sod_qty_ord - sod_qty_ship.
            if sod_qty_ord > 0 and qty_open < 0 then qty_open = 0.
            if sod_qty_ord < 0 and qty_open > 0 then qty_open = 0.
            if qty_open = 0 then next sodloop.

            /*USE allocBy Date Logic */
            if allocBy = "Due Date" then
              tDue = if tDue > sod_due_date then sod_due_date else tDue.
            else if allocBy = "Promised Date" then
              tDue = if tDue > sod_per_date then sod_per_date else tDue.
            else
              tDue = if tDue > sod_req_date then sod_req_date else tDue.
      end.
    end.
    return true.
end function.


function allocateStock returns logical().
   for each t: delete t. end.
   for each d: delete d. end.
   for each srt: delete srt. end.
   for each sum: delete sum. end.
   snapshotStock().
   handleDue().

   soloop:
   for each t
      break by tDue by tnbr :

      tAlloc = no.

      /*DO NOT ALLOCATE FOR SAMPLE ORDERS*/
      if tSamp then next soloop.

      /*DO NOT ALLOCATE FOR CREDIT HOLD*/
      if tHold then next soloop.

      allocloop:
      do transaction on error undo, leave:

        sodloop:
        for each sod_det no-lock
           where sod_domain = global_domain
             and sod_nbr = tnbr
             and (sod_site >= site and sod_site <= site1)
             and not sod_sched
             and ((include_allocated and sod_qty_all <> 0) or
                 (include_picked and sod_qty_pick <> 0) or
                 (include_shipped and sod_qty_ship <> 0) or
                 (include_unprocessed and sod_qty_all = 0
                                      and sod_qty_pick = 0
                                      and sod_qty_ship = 0))
             and (sod_due_date >= due and sod_due_date <= due1)
             and (sod_req_date >= req and sod_req_date <= req1)
             and (sod_prodline >= pl and sod_prodline <= pl1)
          on error undo, next:

          qty_open = sod_qty_ord - sod_qty_ship.
          if sod_qty_ord > 0 and qty_open < 0 then qty_open = 0.
          if sod_qty_ord < 0 and qty_open > 0 then qty_open = 0.
          if qty_open = 0 then next sodloop.

          find s where sPart = sod_part no-error.
          if not avail s then do:
            create s.
            assign
             sPart = sod_part .
          end.

          create d.
          assign
            dNbr  = sod_nbr
            dLn   = sod_line
            dQohl = if sod_type = "" then sQoh - qty_open else sQoh.
          sQoh = sQoh - qty_open.

          /*UNALLOCATE THE ORDER LINE*/
          if dQohl < 0 then do:
             vAlloc = no.
             undo sodloop, next sodloop.
          end.
          else vAlloc = yes.
        end. /*sodloop*/

        tAlloc = vAlloc.
      end.  /* allocloop*/
   end.
   calcShortage().
   return true.
end function.


function calcShortage returns logical().
   soloop:
   for each t
     where tAlloc = no
     and   tSamp  = no,
     first so_mstr no-lock
     where so_nbr = tNbr
     break by tDue by tnbr :

        if (oldcurr <> so_curr) or (oldcurr = "") then do:
           {gprunp.i "mcpl" "p" "mc-get-rnd-mthd"
              "(input  so_curr,
                output rndmthd,
                output mc-error-number)" }
           if mc-error-number <> 0 then do:
             {mfmsg.i mc-error-number 4}
             if c-application-mode <> 'WEB':U then
                pause.
             undo, next.
           end.
           oldcurr = so_curr.
        end.

     sodloop:
     for each sod_det no-lock
       where sod_domain = global_domain
         and sod_nbr = tnbr
         and (sod_site >= site and sod_site <= site1)
         and not sod_sched
         and ((include_allocated and sod_qty_all <> 0) or
              (include_picked and sod_qty_pick <> 0) or
              (include_shipped and sod_qty_ship <> 0) or
              (include_unprocessed and sod_qty_all = 0 and
                                   sod_qty_pick = 0 and
                                   sod_qty_ship = 0))
       and (sod_due_date >= due and sod_due_date <= due1)
       and (sod_req_date >= req and sod_req_date <= req1)
       and (sod_prodline >= pl and sod_prodline <= pl1)
       break by sod_nbr by sod_line:
       qty_open = sod_qty_ord - sod_qty_ship.
       if sod_qty_ord > 0 and qty_open < 0 then qty_open = 0.
       if sod_qty_ord < 0 and qty_open > 0 then qty_open = 0.
       if qty_open = 0 then next sodloop.

       find s where /*sSite = sod_site and*/ sPart = sod_part no-error.
       if not avail s then do:
         create s.
         assign
          sPart = sod_part .
       end.

       create d.
       assign
         dNbr  = sod_nbr
         dLn   = sod_line
         dQohl = sQoh - qty_open.

       if dQohl < 0 then do:

         curr_price = sod_price.
         run getExtPrice (input so_curr,
                          input so_ex_rate,
                          input so_ex_rate2,
                          input sod_price,
                          input if sQoh > 0 then qty_open - sQoh else qty_open).

         find srt where stPart = sod_part no-error.
         if not avail srt then do:
           create srt.
           stPart = sod_part.
         end.
         assign
           stln    = stln    + 1
           stQty   = stQty   + (if sQoh > 0 then qty_open - sQoh else qty_open)
           stSales = stSales + ext_base_price
           stOrd   = if stlOrd <> sod_nbr then stOrd  + 1 else stOrd
           stlOrd  = sod_nbr.
       end.

       /*UPDATE STOCK QOH*/
       sQoh = sQoh - qty_open.
     end. /* for each sod_det*/
   end.  /* for each t*/
   return true.

 end function.
