/* bmpkccb.p - SIMULATED PICKLIST COMPONENT AVAILABILITY CHECK          */

define input parameter isite like in_site.
define input parameter ipart like ps_par.
define input parameter iqty like pt_batch.
define input parameter iseq as integer.

&SCOPED-DEFINE bmpkccb_p_1 "Op"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_2 "Component"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_3 "Net OH"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_4 "As of"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_5 "Ph"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_6 "BOM"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_7 "Ph/"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_8 "Available"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_9 "Item Not in Inventory"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_10 "Use up Ph"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_11 "Reqd"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_12 "Quantity"
/* MaxLen: Comment: */

&SCOPED-DEFINE bmpkccb_p_13 "Short"
/* MaxLen: Comment: */

{mfdeclre.i}

{wbrp02.i}

define new shared workfile pkdet no-undo
    field pkpart like ps_comp
    field pkop as integer format ">>>>>9"
    field pkstart like pk_start
    field pkend like pk_end
    field pkqty like pk_qty
    field pkbombatch like bom_batch
    field pkltoff like ps_lt_off.

define shared temp-table wf-oh no-undo
    field ohpart like ps_comp
    field ohqty like pk_qty
    index ps_comp as primary ohpart.

define shared temp-table ck-out no-undo
    fields ckseq as integer
    fields ckpar like ps_par
    fields ckqty like pt_batch
    fields ckcomp like ps_comp
    fields ckph   like pt_phantom
    fields ckreq  like pt_batch
    fields ckum   like pt_um
    fields ckavail like      in_qty_oh
    fields ckshort like in_qty_oh
index ckseq as primary ckseq
index ckcomp ckcomp.

define new shared variable comp like ps_comp.
define new shared variable eff_date as date   label {&bmpkccb_p_4}.
define new shared variable qty like pt_batch  label {&bmpkccb_p_12}.
define variable spkqty like pt_batch.

define variable part like ps_par.
define variable last_part like pt_part.
define variable desc1 like pt_desc1.
define variable um like pt_um.
define variable qavail as decimal format ">>>,>>9.9<<<<<" label {&bmpkccb_p_13}.
define variable qty_oh as decimal format "->>>,>>9.9<<<<<" label {&bmpkccb_p_8}.
define new shared variable net_oh like mfc_logical initial no label {&bmpkccb_p_3}.
define new shared variable use_up like mfc_logical initial yes label {&bmpkccb_p_10}.
define new shared variable site like in_site no-undo.

define variable transtype as character format "x(4)".

define new shared variable op as integer label {&bmpkccb_p_1} format ">>>>>9".
define new shared variable phantom like mfc_logical initial yes.

{gpxpld01.i "new shared"}

transtype = "BM".

part = ipart.
eff_date = today.
qty = iqty.
site = isite.
for first pt_mstr no-lock
    where pt_domain = global_domain
      and pt_part = part:
end.
if available pt_mstr then um = pt_um.
net_oh = no.
use_up = yes.
op = 0.

function isSubAssembly returns logical (iPart as character).

    for first ptp_det no-lock
        where ptp_domain = global_domain
          and ptp_site = site
          and ptp_part = iPart:
    end.
    if available ptp_det then do:
        if ptp_pm_code = "P" then
            return no.
        else
            return yes.
    end.
    for first pt_mstr no-lock
        where pt_domain = global_domain
          and pt_part = iPart:
    end.
    if available pt_mstr and pt_pm_code = "P" then
        return no.
    else
        return yes.

end function.

if (c-application-mode <> 'web':u) or
    (c-application-mode = 'web':u and (c-web-request begins 'data':u))
then do:

    for first bom_mstr no-lock
        where bom_domain = global_domain
          and bom_parent = part:
    end.

    for first pt_mstr no-lock
        where pt_domain = global_domain
          and pt_part = part:
    end.
    desc1 = "".
    um = "".
    if not available pt_mstr and not available bom_mstr then do:
        {mfmsg.i 17 3}  /* PART NUMBER NOT FOUND */
        if c-application-mode = 'web':u then return.
        undo, retry.
    end.

    if transtype = "FM" then do:
        if available bom_mstr then do:
           if qty = 0 then do:
                if bom_batch <> 0 then qty = bom_batch.
                else qty = 1.
           end.
           desc1 = bom_desc.
           um = bom_batch_um.
        end.
        else do:
           desc1 = pt_desc1.
           um = pt_um.
        end.
    end.
    else do:
        if available pt_mstr then do:
            if qty = 0 then do:
                for first ptp_det no-lock
                    where ptp_domain = global_domain
                      and ptp_part = pt_part
                      and ptp_site = site:
                end.
                if available ptp_det then qty = ptp_ord_qty.
                else qty = pt_ord_qty.
                if qty = 0 then qty = 1.
            end.
            desc1 = pt_desc1.
            um = pt_um.
        end.
        else do:
            if qty = 0 then qty = 1.
            desc1 = bom_desc.
            um = bom_batch_um.
        end.
    end.

    for first si_mstr no-lock
        where si_domain = global_domain
          and si_site = site:
    end.
    if not available si_mstr then do:
        {mfmsg.i 708 3}
        if c-application-mode = 'web':u then return.
        else next-prompt site.
        undo, retry.
    end.

end.

comp = part.

for first ptp_det no-lock
    where ptp_domain = global_domain
      and ptp_part = part
      and ptp_site = site:
end.
if available ptp_det then do:
    if index("1234",ptp_joint_type) > 0 then do:
        {mfmsg.i 6519 1}
        /* MAY NOT INQUIRE/REPORT ON JOINT PRODUCTS */
        if c-application-mode = 'web':u then return.
        undo, retry.
    end.
    if ptp_bom_code > "" then comp = ptp_bom_code.
end.
else if available pt_mstr then do:
    if index("1234",pt_joint_type) > 0 then do:
        {mfmsg.i 6519 1}
        /* MAY NOT INQUIRE/REPORT ON JOINT PRODUCTS */
    if c-application-mode = 'web':u then return.
        undo, retry.
    end.
    if pt_bom_code > "" then comp = pt_bom_code.
end.

/* explode part by standard picklist logic */
if comp <> last_part then do:
    if use_up then do:
        /*Explode with use-up phantom onhand logic*/
        {gprun.i ""bmpkcca.p""}
    end.
    else do:
        /*Explode w/out use-up phantom onhand logic*/
        {gprun.i ""woworla2.p""}
    end.
end.

for each pkdet no-lock
   where eff_date = ? or (eff_date <> ? and (pkstart = ? or pkstart <= eff_date)
                                        and (pkend = ? or eff_date <= pkend)
                                        and ((pkop = op or op = 0))
                         )
   break by pkpart:

    for first pt_mstr no-lock
        where pt_domain = global_domain
          and pt_part = pkpart:
    end.

    if first-of(pkpart) then spkqty = 0.
    spkqty = spkqty + pkqty.

    if last-of(pkpart) then do:
        /*INVENTORY*/
        find first wf-oh where ohpart = pkpart no-error.
        if not available wf-oh then do:
            create wf-oh.
            assign ohpart = pkpart.
            for first in_mstr no-lock
                where in_domain = global_domain
                  and in_part = pkpart
                  and in_site = site:
            end.
            if available in_mstr then assign ohqty = in_qty_oh.
            else assign ohqty = 0.
        end.

        create ck-out.
        assign ckseq   = iseq
               ckpar   = ipart
               ckqty   = iqty
               ckcomp  = pkpart
               ckreq   = spkqty
               ckavail = ohqty
               ckum    = pt_um.
        assign ohqty = ohqty - spkqty.
        if ohqty < 0 then assign ohqty = 0.
        assign ckshort = ckreq - ckavail.
        if ckshort < 0 then ckshort = 0.
    end.

end. /*for each pkdet*/
